#ifndef CONFIG_H_
#define CONFIG_H_
#include "Arduino.h"

//enable debugging
#define DISABLE_I2C
#undef US_TIMER
#define DEBUG
// see https://forum.arduino.cc/index.php?topic=343240.0
#ifdef DEBUG
#define DPRINT(...)    SerialUSB.print(__VA_ARGS__)
//#define DPRINT(args...)    SerialUSB.print(args))
#define DPRINTLN(...)  SerialUSB.println(__VA_ARGS__)
#define DPRINTF(...)    SerialUSB.print(F(__VA_ARGS__))
#define DPRINTLNF(...) SerialUSB.println(F(__VA_ARGS__))

#else
#define DPRINT(...)     //blank line
#define DPRINTLN(...)   //blank line
#define DPRINTF(...)    //blank line
#define DPRINTLNF(...)  //blank line

#endif


// PIN CONFIGURATION
#define I2C_PWM_D             (11)
#define I2C_PWM_C             (13)
#define I2C_MAG_D             (20)
#define I2C_MAG_C             (21)
#define MUXSEL_0              (38)
#define MUXSEL_1              (2)
#define MUXSEL_2              (5)
#define H_EN                  (10)
#define US_TRIG               (12)
#define US_ECHO               (6)
#define MODE_PROX             (4)
#define MODE_DIR              (3)
#define CHRG_PG               (1)
#define CHRG_CHRG             (0)
#define CHRG_FULL             (22)
#define THERM_BATT            (17)
#define V_BATT                (18) 
#define INTENSITY_CTRL        (8)
#define THERM_AMB             (9)


// parameter configs
#define US_MAX_DISTANCE_CM 200

//Constants for the i2c interface of PWM driver
#define PCA9635_ADDR                    (0x62)
#define PCA9635_ADDR                    (0x8)


#endif


