#ifndef ULTRASONICMODULE_H_
#define ULTRASONICMODULE_H_

#include "NewPing.h"
#include "Arduino.h"
#include "filter.h"

#undef US_TIMER

/* Module to manage reading the ultrasonic sensors */
class UltrasonicModule
{
  private:
    NewPing sonar;                  // the ping sensor instance
    MedianFilter filter[8];         // a median filter for each sensor
    volatile uint32_t data[8];      // data array to hold the filtered us values
    volatile uint8_t currentSensor; // the current sensor in the ping cycle
    volatile uint8_t go;            // flag whether to ping next sensor
    
    
  public:
    UltrasonicModule();
    void init();
    void getData(uint32_t * data);  // get data out of the volatile class array
    void start();                   // start ping cycle
    void stop();                    // stop ping cycle
    void pingHandler();             // handler to check for response
    void pingNext();                // helper to ping next sensor
};
    

#endif

