﻿/*Begining of Auto generated code by Atmel studio */
#include <Arduino.h>

/*End of auto generated code by Atmel studio */

// vim: syntax=c tabstop=2 expandtab shiftwidth=2 fo+=tr tw=80

// includes for i2c driver for SAMD
#include <Wire.h>
#include "wiring_private.h" // pinPeripheral() function

// libraries
#include "NewPing.h"

// project modules
#include "config.h"
#include "control_panel.h"
#include "filter.h"
#include "haptic.h"
#include "power.h"
#include "ultrasonicmodule.h"
//#include "us2.h"
#include "magnetometer.h"

//#include "Adafruit_HMC5883_U.h"
//Beginning of Auto generated function prototypes by Atmel Studio
//End of Auto generated function prototypes by Atmel Studio


/* Objects */
Uart serial_debug(&sercom5, 25, 19, SERCOM_RX_PAD_1, UART_TX_PAD_0);
UltrasonicModule um;
Magnetometer mag;
//US2 us2;
control_panel_work_t cp_w;
haptic_work_t h_w;
power_work_t p_w;
float heading;
uint32_t us_data[8];
uint32_t mm_data[8];
uint32_t intensity_array[8];
volatile uint8_t two_hertz;
volatile uint8_t one_hertz;
volatile uint8_t one_fourth_hertz;
volatile uint32_t superTicks;


uint8_t my_map (uint32_t in);
void do_prox_dir();
void do_hazard();
void send_to_haptic();
uint32_t us_to_mm(uint32_t us, uint32_t temp);
uint32_t mm_to_intensity_increment(uint32_t mm);
void do_pulse(uint32_t period);
void timer_setup();

typedef enum state
{
	IDLE,
	POWER_LOW,
	POWER_CHARGING,
	POWER_FULL,
	POWER_HAZARD,
} state_t;

state_t s;

 
 uint8_t i=0;
 uint32_t count = 0;



/***************************************************************
 * Utility Functions 
 */
void SERCOM5_Handler()
{
	serial_debug.IrqHandler();
}
state_t get_next_state(state_t st)
{
	switch(st)
	{
		case IDLE:
			if(p_w.state == CHARGING) return POWER_CHARGING;
			if(p_w.state == FULL) return POWER_FULL;
			if(p_w.state == LOWBATT) return POWER_LOW;
			if(p_w.state == POWER_HAZARD) return POWER_HAZARD;
			if(p_w.state == DISCHARGING) return IDLE;
			return IDLE;
			
		break;
		case POWER_LOW:
			if(p_w.state == CHARGING) return POWER_CHARGING;
			if(p_w.state == FULL) return POWER_FULL;
			if(p_w.state == LOWBATT) return POWER_LOW;
			if(p_w.state == POWER_HAZARD) return POWER_HAZARD;
			if(p_w.state == DISCHARGING) return IDLE;
			return POWER_LOW;
		break;
		case POWER_CHARGING:
			if(p_w.state == CHARGING) return POWER_CHARGING;
			if(p_w.state == FULL) return POWER_FULL;
			if(p_w.state == LOWBATT) return POWER_LOW;
			if(p_w.state == POWER_HAZARD) return POWER_HAZARD;
			if(p_w.state == DISCHARGING) return IDLE;
			return POWER_CHARGING;
		break;
		case POWER_FULL:

			if(p_w.state == CHARGING) return POWER_CHARGING;
			if(p_w.state == FULL) return POWER_FULL;
			if(p_w.state == LOWBATT) return POWER_LOW;
			if(p_w.state == POWER_HAZARD) return POWER_HAZARD;
			if(p_w.state == DISCHARGING) return IDLE;
			return POWER_FULL;
		break;
		case POWER_HAZARD:
			return POWER_HAZARD;
		break;
		default:
			return st;
	}
}

void do_state_action(state_t st)
{
	  // Updates
	  control_panel_update();
	  power_update();
	  um.getData(us_data);
	  //us2.getData(us_data)
	  heading = mag.getHeading();
	  
	  for(int i=0; i < 8; i++)
	  {
		          intensity_array[i] =0;
	  }
	 
	switch(st)
	{
		case IDLE:
			do_prox_dir();
			break;
		case POWER_LOW:
			do_prox_dir();
			do_pulse(400);
			break;
		case POWER_CHARGING:
			do_prox_dir();
			do_pulse(100);
			break;
		case POWER_FULL:
			do_prox_dir();
			do_pulse(50);
			break;
		case POWER_HAZARD:
			do_hazard();
			break;		  
	  }

	  send_to_haptic();
	  // SerialUSB.write(27);       // ESC command
	  //SerialUSB.print("[2J");    // clear screen command
	  //  SerialUSB.write(27);
	  // SerialUSB.print("[H");     // cursor to home command
	  // delay(500);
	
}
void setup() {
  //SerialUSB.begin(115200);
  delay(200);
  serial_debug.begin(115200);
  pinPeripheral(19, PIO_SERCOM_ALT);
  pinPeripheral(25, PIO_SERCOM_ALT);
  
  s = IDLE;
  um.init();
  mag.begin();
  mag.setMeasurementMode(HMC5883L_CONTINOUS);
  mag.setRange(HMC5883L_RANGE_2_5GA);
  mag.setSamples(HMC5883L_SAMPLES_8);

  heading = 0;
  //us2.init();
  //us2.start();
  control_panel_setup(&cp_w);
  haptic_setup(&h_w);
  power_setup(&p_w);
  h_w.enable = 1;
  two_hertz = 1;
  timer_setup();
}

void loop() {

	s = get_next_state(s);
	do_state_action(s);
	
	//serial_debug.print("hello\n");
	
	digitalWrite(H_EN, 0);
	delay(10);
	digitalWrite(H_EN, 1);
	delay(10);
	digitalWrite(H_EN, 0);
	delay(10);
	//delay(50);
	//DPRINT("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
//	SerialUSB.write(27);
//	DPRINT("[2J");
}


#define MAX_INPUT 1<<15;

uint8_t my_map (uint32_t in)
{
//	float scale = cp_w.intensity/1024.0;
//	float b = ((float)in)/MAX_INPUT;
//	uint8_t c = ((uint8_t)(b*scale*(1<<7))) + 1<<7;
//	return 256 - c;
	uint16_t i = cp_w.intensity>>3;
	return map(in, 100, (1<<14), (1<<7), (1<<7)+i);
}

void apply_prox()
{
	for(int i=0; i < 8; i++)
	{
	    mm_data[i] = us_to_mm(us_data[i],cp_w.amb_temp);
		intensity_array[i] += mm_to_intensity_increment(us_to_mm(us_data[i], cp_w.amb_temp));
		//intensity_array[i] += constrain(map(us_data[i],100, 1<<16, 1<<20, 0),0,1<<20);
		//intensity_array[i] += constrain((signed(1<<14) - us_data[i]),0,(1<<16))<<5;
		//intensity_array[i] += constrain(us_data[i]<<4, 0, 1<<20);
	    /// DPRINT("SENSOR "); DPRINT(i); DPRINT(" has "); DPRINT(h_w.dutys[i]); DPRINT("\n");  
		DPRINT("SENSOE "); DPRINT(i); DPRINT(": Distance("); DPRINT(mm_data[i]);DPRINT(")\n");
	}	
}

void apply_dir()
{
	 uint32_t i = (heading+180)/45;
	 if(i >=8) i = 8;
	 if(1 || two_hertz)
	 {
		 intensity_array[i] = constrain(intensity_array[i] + 2048, 0, 4096);
	 }
}

void do_prox_dir()
{
	if(cp_w.prox)apply_prox();
	if(cp_w.dir)apply_dir();
}

void do_hazard()
{
	h_w.enable = 0;
}

void do_pulse(uint32_t period)
{
	static uint32_t lastPeriod = 0;
	static uint32_t lastCount = 0;
	static uint32_t duration = 0;
	if(period != lastPeriod)
	{
		lastPeriod = period;
		lastCount = superTicks;
		duration = 1;
	}
	else
	{
		uint32_t compare = superTicks;
		if(superTicks < lastCount) compare += lastCount;
		if(compare - lastCount > period)
		{
			duration = 1;
			lastCount = superTicks;
		}
		else
		{
			if(duration > 0) duration--;
		}
	}
	
	if(duration > 0)
	{
		for(uint8_t i = 0; i < 8; i++)
		{
			intensity_array[i] += 4096;
		}
	}
}

void send_to_haptic()
{
	uint32_t inl = 0;
	uint32_t inh = 4096;
	uint8_t outl = 128;
	uint8_t outh = (cp_w.intensity/8)+128;
	
	
	for(int i=0; i < 8; i++)
	{
		DPRINT("intensity "); DPRINT(i); DPRINT(" = "); DPRINT(intensity_array[i]); DPRINT("\n");
		#ifdef USE_LEDS
			h_w.dutys[i] = map(constrain(intensity_array[i], inl, inh), inl, inh, 0, outh);
		#else	
			//h_w.dutys[i] = map(constrain(intensity_array[i], inl, inh), inl, inh, outl, outh);
			h_w.dutys[i] = constrain(map(intensity_array[i], inl, inh, outl, outh),128,255);
		#endif
	}
	haptic_update();
}

uint32_t us_to_mm(uint32_t us, uint32_t temp)
{
	// see http://hyperphysics.phy-astr.gsu.edu/hbase/Sound/souspe.html
	return (331.4 + 0.6*temp)*(us)/2000.0;
}


uint32_t mm_to_intensity_increment(uint32_t mm)
{
	// if less than 20cm, ignore
	//return 4096;
	if(mm < 200) return 0;
	if(mm < 300) return 4096;
	if(mm < 600) return 2046;
	if(mm < 1000) return 768;
	if(mm < 1400) return 128;
	else return 0;
		//else return constrain(map(mm, 0, 2000, 4096, 0), 0, 4096);
}


void timer_setup()
{
    REG_GCLK_GENDIV = GCLK_GENDIV_DIV(4) |    // Divide the 48MHz system clock by 4 = 12 MHz
                    GCLK_GENDIV_ID(5);      // Set division on Generic Clock Generator (GCLK) 5
  while (GCLK->STATUS.bit.SYNCBUSY);        // Wait for synchronization

  REG_GCLK_GENCTRL = GCLK_GENCTRL_IDC |           // Set the duty cycle to 50/50 HIGH/LOW
                     GCLK_GENCTRL_GENEN |         // Enable GCLK 5
                     GCLK_GENCTRL_SRC_DFLL48M |   // Set the clock source to 48MHz
                     GCLK_GENCTRL_ID(5);          // Set clock source on GCLK 5
  while (GCLK->STATUS.bit.SYNCBUSY);              // Wait for synchronization

  REG_GCLK_CLKCTRL = GCLK_CLKCTRL_CLKEN |         // Enable the generic clock...
                     GCLK_CLKCTRL_GEN_GCLK5 |     // ....on GCLK5
                     // Hack to overcome define problem in next line!!!
                     0x1A;                        // Feed the GCLK5 to TCC0 and TCC1
  while (GCLK->STATUS.bit.SYNCBUSY);              // Wait for synchronization

 
 
  // Enable standard clock for TC0_TCC1
// REG_GCLK_CLKCTRL = (uint16_t) (GCLK_CLKCTRL_CLKEN | GCLK_CLKCTRL_GEN_GCLK0 | 0x1A  ) ;
// while ( GCLK->STATUS.bit.SYNCBUSY == 1 ); // wait for sync


  // The type cast must fit with the selected timer
  Tcc* TC = (Tcc*) TCC0; // get timer struct
 
  TC->CTRLA.reg &= ~TCC_CTRLA_ENABLE;   // Disable TC
  while (TC->SYNCBUSY.bit.ENABLE == 1); // wait for sync

   TC->CTRLA.reg |= TCC_CTRLA_PRESCALER_DIV8;   // Set prescaler

  TC->WAVE.reg |= TCC_WAVE_WAVEGEN_NFRQ;   // Set wave form normal freq.
  while (TC->SYNCBUSY.bit.WAVE == 1); // wait for sync

 TC->PER.reg = 0x3A98;              // Set counter Top using the PER register 
 while (TC->SYNCBUSY.bit.PER == 1); // wait for sync

//  TC->CC[0].reg = 0xFFF;
 // while (TC->SYNCBUSY.bit.CC0 == 1); // wait for sync
 
  // Interrupts
  TC->INTENSET.reg = 0;                 // disable all interrupts
  TC->INTENSET.bit.OVF = 1;          // enable only overfollow

  // Enable InterruptVector
  NVIC_EnableIRQ(TCC0_IRQn);

  // Enable TC
  TC->CTRLA.reg |= TCC_CTRLA_ENABLE ;
  while (TC->SYNCBUSY.bit.ENABLE == 1); // wait for sync
  superTicks = 0;
  one_fourth_hertz = 0;
  two_hertz = 0;
  one_hertz = 0;

}
void TCC0_Handler()
{
  Tcc* TC = (Tcc*) TCC0;       // get timer struct
  if (TC->INTFLAG.bit.OVF == 1) {  // A overflow caused the interrupt
    superTicks++ ;                  // Increlent superTick register
	if(superTicks >= 100000) superTicks = 0;
    TC->INTFLAG.bit.OVF = 1;    // writing a one clears the flag ovf fla
	
	
	
  }
  
}