#ifndef CONFIG_H_
#define CONFIG_H_
#include "Arduino.h"

//enable debugging
//#define DISABLE_I2C_PWM
//#define DISABLE_I2C_MAG
extern Uart serial_debug;
#undef US_TIMER
//#define USE_LEDS
#define DEBUG_P
// see https://forum.arduino.cc/index.php?topic=343240.0
#ifdef DEBUG_P
#define DPRINT(...)    serial_debug.print(__VA_ARGS__)
//#define DPRINT(args...)    SerialUSB.print(args))
#define DPRINTLN(...)  serial_debug.println(__VA_ARGS__)
#define DPRINTF(...)    serial_debug.print(F(__VA_ARGS__))
#define DPRINTLNF(...) serial_debug.println(F(__VA_ARGS__))

#else
#define DPRINT(...)     //blank line
#define DPRINTLN(...)   //blank line
#define DPRINTF(...)    //blank line
#define DPRINTLNF(...)  //blank line

#endif

// see https://forum.arduino.cc/index.php?topic=363393.0 for changes made to arduino core for access to analog A6, A7, and A8
// PIN CONFIGURATION
#define I2C_PWM_D             (11)
#define I2C_PWM_C             (13)
#define I2C_MAG_D             (3)
#define I2C_MAG_C             (4)
#define MUXSEL_0              (38)
#define MUXSEL_1              (2)
#define MUXSEL_2              (5)
#define H_EN                  (10)
#define US_TRIG               (12)
#define US_ECHO               (6)
#define MODE_PROX             (20)
#define MODE_DIR              (21)
#define CHRG_PG               (1)
#define CHRG_CHRG             (0)
#define CHRG_FULL             (22)
//#define THERM_BATT            (17)
#define THERM_BATT            (A3)
//#define V_BATT                (18)
#define V_BATT                (A4) 
//#define INTENSITY_CTRL        (8)
#define INTENSITY_CTRL        (A1)
//#define THERM_AMB             (9)
#define THERM_AMB             (A2 )


// parameter configs
#define US_MAX_DISTANCE_CM 175

//Constants for the i2c interface of PWM driver
#define PCA9635_ADDR                    (0x55)
//#define PCA9635_ADDR                    (0x8)


#endif


