#include "control_panel.h"
#include "config.h"
#include "Arduino.h"

control_panel_work_t *c_work;
float control_panel_adc_to_degreec(uint32_t adc);

void control_panel_setup(control_panel_work_t * wrk)
{
  DPRINT(("setup_control_panel(): setting control panel pin modes\n"));
  pinMode(MODE_DIR, INPUT);
  pinMode(MODE_PROX, INPUT);
  pinMode(INTENSITY_CTRL, INPUT);
  pinMode(THERM_AMB, INPUT);
	// save pointer to work;
	c_work = wrk;
}


void control_panel_update()
{
	c_work->dir = digitalRead(MODE_DIR);
	c_work->prox = digitalRead(MODE_PROX);
	c_work->intensity = analogRead(INTENSITY_CTRL);
	c_work->amb_temp = control_panel_adc_to_degreec(analogRead(THERM_AMB));

 DPRINT("Control Panel Update: MODE_DIR=");
 DPRINT(c_work->dir, DEC);
 DPRINT(" MODE_PROX=");
 DPRINT(c_work->prox, DEC);
 DPRINT(" INTENSITY_CTRL=");
 DPRINT(c_work->intensity, DEC);
 DPRINT(" THERM_AMB=");
 DPRINT(c_work->amb_temp);
 DPRINT("\n");
}

float control_panel_adc_to_degreec(uint32_t adc)
{
	return (((adc/1024.0*3300)-500.0)/10.0);
}

