#include "filter.h"
#include "Arduino.h"

MedianFilter::MedianFilter(uint32_t initialValue)
{
	for(int i=0; i < SIZE; i++)
	{
		samples[i] = initialValue;
	}
	head = 0;
	num_bad = 0;
}

MedianFilter::MedianFilter()
{
  MedianFilter(0);
}

uint32_t MedianFilter::getFilteredValue( uint32_t measurement)
{
	
	if(measurement != 0)
	{
		samples[head] = measurement;
		head = (head+1)%SIZE;
		if(num_bad > 0) num_bad--;
	}
	else
	{
		if(num_bad < SIZE) num_bad++;
	}
	return getMedian();
}

void MedianFilter::addSample(uint32_t meas)
{
	
	if(meas == 0) return;
	samples[head] = meas;
	head = (head+1)%SIZE;
}

uint32_t MedianFilter::getMedian()
{
	uint32_t t[SIZE];
	uint32_t tmp = 0;
	//if(num_bad == SIZE) return 0; //if we've gotten a buffer's worth of bad samples, report a zero.
	for(int i=0; i<SIZE; i++)
	{
		t[i] = samples[i];
	}

	for(int i=0; i <= SIZE/2; i++)
	{
		for(int j=i; j<SIZE; j++)
		{
			if(t[i] < t[j]) 
			{
				tmp = t[i];
				t[i] = t[j];
				t[j] = tmp;
			}
		}
	}
	return t[SIZE/2];
}

				
			
				


		


