#include "haptic.h"
#include "config.h"
#include "Arduino.h"

#include "Wire.h"
#include "wiring_private.h" // pinPeripheral() function

#define I2C_RESET_ADDR                  (0x03)
#define PCA9635_LED_AUTOINC             (0xA2)
#define PCA9635_CONTROL_AUTOINC         (0x80)
#define MODE1_CONFIG (0x80)
//#define MODE2_CONFIG (0x15)
#define MODE2_CONFIG (0x7)

void setup_pwm();

haptic_work_t * w;
TwoWire i2c_pwm(&sercom1, I2C_PWM_D, I2C_PWM_C);

void haptic_setup(haptic_work_t* work)
{
  DPRINT(("Setting up the Haptic Module\n"));
	pinMode(H_EN, OUTPUT);
	setup_pwm();
	w = work;
  w->enable = 0;
  digitalWrite(H_EN, HIGH);
}


void haptic_update()
{
	digitalWrite(H_EN, !(w->enable));
  DPRINT("Sending data to PWM: ");
  DPRINT(w->dutys[0], DEC); DPRINT(" "); DPRINT(w->dutys[1], DEC);DPRINT(" "); DPRINT(w->dutys[2], DEC);DPRINT(" "); DPRINT(w->dutys[3], DEC);DPRINT(" "); DPRINT(w->dutys[4], DEC);
  DPRINT(" "); DPRINT(w->dutys[5], DEC);DPRINT(" "); DPRINT(w->dutys[6], DEC);DPRINT(" ");DPRINT(w->dutys[7], DEC);DPRINT(" "); DPRINT("\n");
	#ifndef DISABLE_I2C_PWM
	i2c_pwm.beginTransmission(PCA9635_ADDR);
	i2c_pwm.write(PCA9635_LED_AUTOINC);
	i2c_pwm.write((uint8_t*)(w->dutys), 8);
	i2c_pwm.endTransmission();
	
		i2c_pwm.beginTransmission(PCA9635_ADDR);
	i2c_pwm.write(0x80);
		i2c_pwm.endTransmission();
i2c_pwm.requestFrom(PCA9635_ADDR,32);

	
	

	
	
  #endif
}


void setup_pwm()
{
  DPRINT(("Setting up the PWM Driver I2C\n"));
  uint8_t buffer[10];

  #ifndef DISABLE_I2C_PWM
  //start the phy
  i2c_pwm.begin();
    //mux the correcto pins
  pinPeripheral(I2C_PWM_D, PIO_SERCOM);
  pinPeripheral(I2C_PWM_C, PIO_SERCOM);
  delay(100);
  i2c_pwm.beginTransmission(I2C_RESET_ADDR);
  i2c_pwm.write(0xA5);
  i2c_pwm.write(0x5A);
  i2c_pwm.endTransmission();
//  delay(1000);
  // write the pwm driver config to the MODE1 and MODE2 registers
  i2c_pwm.beginTransmission(PCA9635_ADDR);
  i2c_pwm.write(PCA9635_CONTROL_AUTOINC);
  i2c_pwm.write(MODE1_CONFIG);
  i2c_pwm.write(MODE2_CONFIG);
  i2c_pwm.endTransmission();

/*
    delay(5000);
i2c_pwm.beginTransmission(PCA9635_ADDR);    // Get the slave's attention, tell it we're sending a command byte
i2c_pwm.write(0x80);                               //  The command byte, sets pointer to register with address of 0x32
 i2c_pwm.endTransmission(false);
i2c_pwm.requestFrom(PCA9635_ADDR,1);          // Tell slave we need to read 1byte from the current register
int num = i2c_pwm.readBytes(buffer, 10);        // read that byte into 'slaveByte2' variable
i2c_pwm.endTransmission();
    delay(5000);
	*/
	// turn channels 0 to 7 on
  i2c_pwm.beginTransmission(PCA9635_ADDR);
  i2c_pwm.write(0x94);
  i2c_pwm.write(0xAA);
  i2c_pwm.write(0xAA);
  i2c_pwm.endTransmission();
  #endif
    DPRINT(("Setting up the PWM Driver I2C\n"));
}



