#ifndef POWER_H_
#define POWER_H_

#include "config.h"
#include <Arduino.h>

#define HAZARD_LOW  0
#define HAZARD_HIGH  744

#define LOW_BATT_THRESHOLD  200

typedef enum power_state
{
	DISCHARGING,
	CHARGING,
	FULL,
	LOWBATT,
	HAZARD
} power_state_t;

typedef struct
{
	uint32_t vbat;
	uint32_t therm_bat;
	power_state_t state;
} power_work_t;


void power_setup(power_work_t *work);

void power_update();


#endif

