#ifndef US2_H_
#define US2_H_

#include <Arduino.h>
#include "filter.h"
#include <stddef.h>


class US2
{
    public:
        US2();
        void init();
        uint32_t start();
        uint32_t stop();
        uint32_t getData(uint32_t * buf, uint8_t size);
        uint32_t gotIRQ(uint32_t sample);

    private:
	    MedianFilter filter[8];
        volatile uint32_t pulseComplete;
        volatile uint32_t pulseWidth;
        volatile uint32_t currentSensor;
        volatile uint32_t data[8];
		volatile float ambTemp;

        static void enableInterrupts();
        static void disableInterrupts();
        static void setupTimers();
        static void handler();
        static void setupUltrasonicMux();
        static void selectSensor(uint8_t n);
		static US2* registeredInstance;
		static float adcToTemp(uint32_t amb);
		friend void TC4_Handler();

};


void TC4_Handler();


#endif





